# -*- coding: utf-8 -*-
#######################################################################
#
#	TestPlugin
##
#######################################################################

#Globals
import os
import re
from enigma import eTimer

from Components.ActionMap import ActionMap, HelpableActionMap
from Components.config import config, ConfigSubsection, ConfigDirectory, ConfigYesNo, ConfigSelection, ConfigInteger, ConfigText, ConfigBoolean, getConfigListEntry, configfile 
from Components.Label import Label
from Components.Sources.StaticText import StaticText   #!!!!!neu

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox

# own modules
#from myLogger import LOG
#-----------------

from Components.GUIComponent import GUIComponent
from Components.MultiContent import MultiContentEntryText

#from Components import Renderer
#from Components import ConditionalWidget

from enigma import eVideoWidget

from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_VALIGN_CENTER, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER
from enigma import eServiceCenter, eServiceReference, getDesktop, iServiceInformation, iPlayableService
from enigma import ePythonMessagePump

#from Components.FileList import FileList
from Components.Label import Label
from Components.Pixmap import Pixmap, MultiPixmap
from Components.ScrollLabel import ScrollLabel
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from Components.Sources.EventInfo import EventInfo

from datetime import timedelta as datetime_timedelta, datetime as datetime_datetime

##from tinytag import TinyTag

import mutagen
import base64

from mutagen.apev2 import APEv2
from mutagen.easyid3 import EasyID3
from mutagen.easymp4 import EasyMP4
from mutagen.flac import Picture, FLAC, StreamInfo, error as FLACError
from mutagen.id3 import ID3
from mutagen.mp3 import MP3
from mutagen.oggvorbis import OggVorbis


import shutil
import random

from Screens.ChoiceBox import ChoiceBox
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarNotifications
from Screens.MessageBox import MessageBox
from Screens.HelpMenu import HelpableScreen
from Screens.VirtualKeyBoard import VirtualKeyBoard

from ServiceReference import ServiceReference

import sqlite3

from threading import Thread, Lock

from time import time, strftime
from timer import TimerEntry

from Tools.BoundFunction import boundFunction
#from Tools.Directories import fileExists, resolveFilename, SCOPE_CURRENT_SKIN, SCOPE_CONFIG

##from twisted.web import client
from twisted.web.client import downloadPage, getPage

from urllib import quote, quote_plus, unquote

from xml.etree.cElementTree import fromstring as xml_fromstring
import xml.etree.ElementTree as xmlET

from Components.Sources.StaticText import StaticText
from Tools.Directories import *

#from Components.Sources import Boolean
from Components.Sources.Boolean import Boolean
from skin import parseColor

import requests

global logPath


class TestPluginScreen(Screen, InfoBarBase, InfoBarSeek, InfoBarNotifications, HelpableScreen):
	def __init__(self, session):
		global logPath
		Screen.__init__(self, session)

		logPath = config.plugins.yampmusicplayer.debugPath.value
		logPath = 'media/usb/TestPlugin/Log/'
		timestamp = datetime_datetime.now().strftime("%Y-%m-%d_%H-%M-%S")
		logPath= logPath + 'test_debug_' + timestamp  + '.log'			


		baseDir = "/usr/lib/enigma2/python/Plugins/Extensions/TestPlugin/"
		with open(os.path.join(baseDir, "TestPlugin.xml"), 'r') as f:
			self.skin = f.read()
			
#		InfoBarBase.__init__(self)
#		InfoBarNotifications.__init__(self)
		HelpableScreen.__init__(self)

	
		self.session = session
		self.myOldService = self.session.nav.getCurrentlyPlayingServiceReference()
#		if self.TvOff: self.session.nav.stopService()

		self["line1"] = Label (".")
		self["line2"] = Label (".")

		self["title"] = Label("TestPlugin S  ")
		self["button_red"] = Label()
		self["button_green"] = Label()
		self["button_yellow"] = Label()
		self["button_blue"] = Label()
		
		self["key_red"] = Label (_("Beenden"))
		self["key_green"] = Label (_("Test Request"))
		self["key_yellow"] = Label ()
		self["key_blue"] = Label ("")

		self["Ausgabe"] = Label ("")


# Timers
		self.isDreamOS = os.path.exists("/var/lib/dpkg/status")
		self.testTimer = eTimer()
		if self.isDreamOS: self.testTimer_conn=self.testTimer.timeout.connect(self.testTimerTimeout)
		else:	self.testTimer.callback.append(self.testTimerTimeout)
		
		
		# Action maps		
		self["Actions"] = HelpableActionMap(self,"TestPluginActions",
		{
			"exit": (self.exit, _("Exit plugin")),
			"menu": (self.showMenu, _("Show context menu")),				
			"right" : (self.right, _("Right")),
			"left" : (self.left, _("Left")),
			"info" : (self.info, _("Info")),
		}, -2)

		self["OtherActions"] = ActionMap(["TestPluginOtherActions"],
		{
			"red": self.redActions,
			"redLong": self.redLongActions,
			"green": self.greenActions,
			"greenLong": self.greenLongActions,
			"yellow": self.yellowActions,
			"yellowLong": self.yellowLongActions,
			"blue": self.blueActions,
			"blueLong": self.blueLongActions,
		}, -2)
		
		self["HelpActions"] = ActionMap(["TestPluginHelpActions"],
		{
			"help": self.showHelp,
		}, -2)
		

	def lockShow(self):
		pass

	def unlockShow(self):
		pass


#
	def layoutFinished(self):
		pass
		
	def ok(self):
		print '=== ok pressed'
	
	def exit(self):
		print '=== exit pressed'
		self.close(self.session)
#		self.close(self.session, self.myOldService)
		

	def showMenu(self):
		print '=== menu pressed'

	def right(self):
		print '=== right pressed'
	
	def left(self):
		print '=== left pressed'
	
	def info(self):
		print '=== info pressed'

	def redActions(self):
		print '=== redActions pressed'
		self.close(self.session)
#		self.close(self.session, self.myOldService)
	
	def redLongActions(self):
		print '=== redLongActions pressed'
	
	def greenActions(self):
		self.testRequest()
#		LOG('grün gedrückt')
#		print '=== greenActions pressed'
		
	def greenLongActions(self):
		print '=== greenLongActions pressed'

	def yellowActions(self):
		self["Ausgabe"].setText("")
		self["key_yellow"].setText("")
#		print '=== yellowActions pressed'
	
	def yellowLongActions(self):
		print '=== yellowLongActions pressed'
	
	def blueActions(self):
		print '=== blueActions pressed'
	
	def blueLongActions(self):
		print '=== blueLongActions pressed'



	def testRequest(self):
		from twisted.internet import ssl
		try:
			_create_unverified_https_context = ssl._create_unverified_context
		except AttributeError:
			# Legacy Python that doesn't verify HTTPS certificates by default
			pass
		else:
			# Handle target environment that doesn't support HTTPS verification
			ssl._create_default_https_context = _create_unverified_https_context


		url = 'https://api.github.com'
#		print '=== testRequest: ', url

		try:
			import requests
		except:
			print '=== import: EXCEPT'
		try:
			user_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:91.0) Gecko/20100101 Firefox/91.0'
			r = requests.get(url, headers={"user-agent": user_agent}, allow_redirects=True, verify=False)
			print '=== ergebnis:', r
			self["Ausgabe"].setText(str(r) +' \n\n ' + r.content)
		except Exception as e:
			self["Ausgabe"].setText('Fehler (EXCEPT):   ' + str(e))
			print '=== ',str(e)
			print '=== requests : EXCEPT'

		self["key_yellow"].setText(_("Ausgabe Löschen"))

#		self.testTimer.start(15000,True)	
		
	def testTimerTimeout(self):
		self["Ausgabe"].setText("")
		
#def LOG(s, type):
def LOG(s):
	writeLog(s)


def writeLog(text):		
	global logPath
	try:
		t = timestamp()
		with open(logPath,'a') as f:
			if len(text) > 0:
				if text[0] == '\n': 
					if len(text) > 1:	f.write('\n' + t + ' ' + text[1:] + '\n')
					else: f.write('\n' + t + '\n')
				else: f.write(t + ' ' + text + '\n')
			else: f.write(t + '\n')
		f.close()
		del t,f,text
	except:
		pass

def timestamp():
	return datetime_datetime.now().strftime("%Y.%m.%d-%H:%M:%S.%f")

